/*-
 * Copyright (C)2002..2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2002..2014 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_copy.c,v 1.37 2014/09/03 18:05:05 babolo Exp $";
#endif /* not lint */

#define BLIN_COMPAT  3
#define Bpars_COMPAT 3
#define MIFE_COMPAT  4

#include <sys/types.h>
#include <sys/event.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include <babolo/parser.h>
#include <mife.h>
#include "pgoblin.h"
#include "pgob.h"

enum fich {fn, fs, fp, fo, fx};
enum finde {finde_beg, finde_eol, finde_bsl, finde_dot, finde_end}; /* "\n\\.\n" */
/* static const char *fichn[] = {"fn", "fs", "fp", "fo", "fx"};
 * static const char *finden[] = {"finde_beg", "finde_eol", "finde_bsl", "finde_dot", "finde_end"};
 */

int
pgoblin_copyout(pgoblin_exenv *exenv, pgoblin_r *r) {
    int f;
    void *res;
    void *buf;
    ssize_t e = 0;

#   define blin_internal_flags (exenv->options->flags & BLIN_MASK)
    ifBLIN_QX3( "+ %08X %s out=%d"
              , R_CONN->flags
              , (char*)IO_CTL->text
              , r[PGO_COUT].r
              );
    if  (!e && !IO_CTL->text) {
        ifBLIN_QX0("pgoblin_copyout: No query");
        e = -1;
        goto out;
    }

    if  (!e) {
        if  ((e = DBASE(R_CONN->flags)->query(R_CONN, &res, IO_CTL->text, PGOBLIN_CR_OUT))) {
            e = -1;
            goto out;
        }
        for (; (f = DBASE(R_CONN->flags)->getcopy(R_CONN, &buf)) > 0 && e >= 0;) {
            ifBLIN_QX2("%d buf=%s", f, (char*)buf);
            if  (strcmp("\\.", buf) == 0) {
                if  (exenv->options->flags & PGOBLIN_COPEND_PASS)
                    e = IO_OUT->wri(IO_OUT->onu, buf, f);
                DBASE(R_CONN->flags)->finish(R_CONN->flags, PGOBLIN_FrCOPY, &buf);
                break;
            }
            e = IO_OUT->wri(IO_OUT->onu, buf, f);
            DBASE(R_CONN->flags)->finish(R_CONN->flags, PGOBLIN_FrCOPY, &buf);
        }
        if  (e < 0) {
            ifBLIN_QX0("getcopy error");
        }
        DBASE(R_CONN->flags)->finish(R_CONN->flags, PGOBLIN_CleaRes, &res);
        if  (DBASE(R_CONN->flags)->endstream(R_CONN, PGOBLIN_CR_OUT)) {
            e = -1;
            goto out;
    }   }
    if  (e < 0) {
        ifBLIN_QX0("write error");
    } else if (exenv->options->flags & PGOBLIN_COPEND_APND) {
        e = IO_OUT->wri(IO_OUT->onu, "\\.\n", 0);
    }
    if  (e < 0) {
        ifBLIN_QX0("write end error");
    }
out:
    ifBLIN_QX3("- %"BLIN_D, e);
    return(e < 0 ? (int)e : 0);
#   undef blin_internal_flags
}

int
pgoblin_copyin(pgoblin_exenv *exenv, pgoblin_r *r) {
    int e = 0, ee;                                                   /*   putcopy */
    ssize_t f = 0;
    void *res;
    char *q, *d;
    enum finde k;
                                                   /*    "\n\\.\n"    */
    const enum fich fich[256] =
    {fn,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fn,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fp,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo

    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fs,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo

    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo

    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo ,fo,fo,fo,fo
    };
    const u_char automa[finde_end][fx] =
    /*      fn         fs         fp         fo */
    {{ finde_eol, finde_beg, finde_beg, finde_beg} /*finde_beg*/
    ,{ finde_beg, finde_bsl, finde_beg, finde_beg} /*finde_eol*/
    ,{ finde_beg, finde_beg, finde_dot, finde_beg} /*finde_bsl*/
    ,{ finde_end, finde_beg, finde_beg, finde_beg} /*finde_dot*/
    };

#   define blin_internal_flags (exenv->options->flags & BLIN_MASK)
    ifBLIN_QX3("+ query=%s", (char*)IO_CTL->text);
    d = NULL;                                                                  /*   COPY */
    q = IO_CTL->text;
    if  (!e && !q) {
        ifBLIN_QX0("No query");
        e = -1;
    }
    if  (!IO_IN->mife) {
        ifBLIN_QX0("No input data");
        e = -1;
    }
    if  (!e) {
        if  ((e = DBASE(R_CONN->flags)->query(R_CONN, &res, q, PGOBLIN_CR_IN))) {
            e = -1;
            goto out;
        }
        ifBLIN_QX3("Copy %d columns", DBASE(R_CONN->flags)->resinfo(PGOBLIN_Nfields, res));
        DBASE(R_CONN->flags)->finish(R_CONN->flags, PGOBLIN_CleaRes, &res);

        for (k = finde_eol, f = 1, e = 0; f > 0 && e == 0; IO_IN->offset += f) {
            char *ofbase;

            if  ((f = mife_ctl(IO_IN->mife, MIFE_CTLREAD, IO_IN->offset, PGOBLIN_BUFSIZE)) < 0) {
                ifBLIN_QW0("mife_ctl(MIFE_CTLREAD)");
                e = -1;
            }
            ifBLIN_QX4("mife_ctl(MIFE_CTLREAD)=%"BLIN_D",", BLIN_I(f));
            ofbase = mife_point(IO_IN->mife, MIFE_POINOFF, IO_IN->offset);
            if  (!e) {
                for (q = ofbase; q < (ofbase + f) && k != finde_end; k = automa[k][fich[(u_char)*q++]])
                    ifBLIN_QX4("%c", *q);
                if  (q - ofbase) {
                    e = DBASE(R_CONN->flags)->putcopy(R_CONN, ofbase, q - ofbase) < 1;
                    ifBLIN_QX3("putcopy=%d %d (%"BLIN_D")", e, k, BLIN_I(q - ofbase));
                } else ifBLIN_QX3("no putcopy %d (%"BLIN_D")", k, BLIN_I(q - ofbase));
        }   }
        if  (!e && k != finde_end) {                       /*  ()    */
            const char *enstin = "\n\\.\n";
            ifBLIN_QX2("end=%s~%d", &enstin[k], finde_end - k);
            e = DBASE(R_CONN->flags)->putcopy(R_CONN, &enstin[k], finde_end - k) < 1;
            ifBLIN_QX3("putcopy=%d %d (%d)", e, k, finde_end - k);
        }
        if  (e) {                                               /*       */
            ifBLIN_QX0("putcopy failed");
            e = -1;
        }
        ee = DBASE(R_CONN->flags)->endstream(R_CONN, PGOBLIN_CR_IN);
        if  (!e && (ee < 0)) {                                  /*       */
            e = -1;
            ifBLIN_QX0("endcopy failed");
    }   }
out:
    ifBLIN_QX3("- %d", e);
    return(e);
#   undef blin_internal_flags
}
