/*-
 * Copyright (C)2015 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pgoblin_style.h,v 1.1 2015/07/13 19:34:05 babolo Exp $
 */

#ifndef _PGOBLIN_STYLE_H_
#define _PGOBLIN_STYLE_H_

__BEGIN_DECLS

typedef struct pgoblin_styreg {
    char            *path;
    void            *style;
    u_int32_t        flags;
#   define           PGOBLIN_STYLE_TYPE   0x00000F
/*                   BLINflag                         copied from pgoblin_main                       */
} pgoblin_styreg;

struct pgoblin_styles;
typedef struct pgoblin_styles pgoblin_styles;

struct pgoblin_styles {
    u_int32_t    flags;
    char       id[PGOBLIN_STRING_ID_LEN];
    char     name[PGOBLIN_STRING_ID_LEN];
    int    (*init)(u_int32_t flags, pgoblin_styles *this);
    int    (*fini)(u_int32_t flags, pgoblin_styles *this);
    int  (*parser)(pgoblin_styreg *reg_style, u_char *in);
    void   (*dump)(pgoblin_styreg *reg_style);
    int   (*clear)(pgoblin_styreg *reg_style);
    char   *(*get)(pgoblin_styreg *reg_style, u_char *stringname);
    int   (*table)( pgoblin_io    *reg_out
                  , pgoblin_styreg*reg_style
                  , pgoblin_io    *reg_in
                  , ssize_t        low
                  , ssize_t        hig
                  );
};

__END_DECLS

#endif /* !_PGOBLIN_STYLE_H_ */
